
import
  preserves, std/tables

type
  Attrs* = Table[Symbol, string]
  Notify* {.preservesRecord: "notify".} = object
    `summary`*: string
    `attrs`*: Attrs

  ServerInfo* {.preservesRecord: "server-info".} = object
    `name`*: string
    `vendor`*: string
    `version`*: string
    `specVersion`*: string

proc `$`*(x: Attrs | Notify | ServerInfo): string =
  `$`(toPreserve(x))

proc encode*(x: Attrs | Notify | ServerInfo): seq[byte] =
  encode(toPreserve(x))
